#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "mpi.h"

typedef struct {
	double value;
	int id;
} valueandid;

int main(int argc, char* argv[]) 
{  
	int			id;
	valueandid 	in, out;

	MPI_Init(&argc, &argv);  
	MPI_Comm_rank(MPI_COMM_WORLD, &id);

	srand( time(NULL)*id );

	in.value = rand()/(double)RAND_MAX;
	in.id = id;

	printf("Proces %d: value = %lf\n", in.id, in.value);

	MPI_Reduce(&in, &out, 1, MPI_DOUBLE_INT, MPI_MAXLOC, 0, MPI_COMM_WORLD);

	if (id == 0)
		printf("Max: %lf, proces: %d\n", out.value, out.id);

	MPI_Finalize();

	return 0;
}
